//+------------------------------------------------------------------+
//|                                            DueMedieCheAprono.mqh |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Giovane Societ"

//dichiarazione classe principale
class DueMedieCheAprono
{
private:

int                MagicNumber; // expert numero magico
double             Lotti; //expert lotti
int                Ma_Handle_Fast; // handle prima media
int                Ma_Handle_Slow; // handle seconda media
double             Ma_Val_Fast[]; // contenitore valori media fast
double             Ma_Val_Slow[]; // contenitore valori media slow
double             ClosePrice; // ultimo prezzo di chiusura
MqlTradeRequest    trequest; // trade request - costrutto per aprire posizioni
MqlTradeResult     tresult; // trade result - risultato operazione
string             symbol; // per memorizzare il simbolo
ENUM_TIMEFRAMES    TimeFrame; // per memorizzare il timeframe

public:

void               DueMedieCheAprono();  //costruttore
void               Setsymbol(string symb) {symbol = symb;}//funzione per modificare il simbolo
void               SetPeriod(ENUM_TIMEFRAMES tmfr) {tmfr = TimeFrame;} // funzione per modificare il periodo
void               SetClosePrice(double clopri) {clopri = ClosePrice;} // funzione per aggiornare l'ultimo prezzo di chiusura'
void               SetLotti(double lots) {lots = Lotti;}  // funzione per modificare lotti
void               SetMagic(int magic) {magic = MagicNumber;} // funzione per modificare il numero magico
void               DoInit(int ma_period_fast, int ma_period_slow); // funzione per inizializzare l'EA
void               DoUninit(); // funzione per deinizializzare l'EA
bool               VerificaLong(); // booleano per verificare condizione entrata long
bool               VerificaShort(); // booleano per verificare conizione entrata short
void               ApriLong(ENUM_ORDER_TYPE otype,double askprice,double SL,
                             double TP,int dev,string comment="posizione long"); // funzione per mandare ordine a mercato long
void               ApriShort(ENUM_ORDER_TYPE otype,double bidprice,double SL,
                              double TP,int dev,string comment="posizione short"); // funzione per mandare ordine a mercato short

protected:

void               GetBuffers(); // funzione per riempire i contenitori

};

//inizializzo le prime cose necessarie
void DueMedieCheAprono::DueMedieCheAprono()
{

ZeroMemory(trequest);
ZeroMemory(tresult);
ZeroMemory(Ma_Val_Fast);
ZeroMemory(Ma_Val_Slow);

}

// costruisco le funzioni per i protected

void DueMedieCheAprono::GetBuffers()
{

CopyBuffer(Ma_Handle_Fast,0,0,1,Ma_Val_Fast);
CopyBuffer(Ma_Handle_Slow,1,0,1,Ma_Val_Fast);

}

//inizializzo alcune public

void DueMedieCheAprono::DoInit(int ma_period_fast,int ma_period_slow)
  {
//inizio a costruire gli inicatori come mi servono

Ma_Handle_Fast=iMA(symbol,TimeFrame,ma_period_fast,0,MODE_EMA,PRICE_CLOSE);
Ma_Handle_Slow=iMA(symbol,TimeFrame,ma_period_slow,0,MODE_EMA,PRICE_CLOSE);

}

void DueMedieCheAprono::DoUninit()
  {
   IndicatorRelease(Ma_Handle_Fast);
   IndicatorRelease(Ma_Handle_Slow);
  }

bool DueMedieCheAprono::VerificaLong()
{

GetBuffers();

bool LongCondition = (Ma_Val_Slow[1] < Ma_Val_Fast[1]);

if (LongCondition == true)
   {
   return(true);
   }
   else
     {
      return(false);
     }
}

bool DueMedieCheAprono::VerificaShort()
{

GetBuffers();

bool ShortCondition = (Ma_Val_Slow[1] > Ma_Val_Fast[1]);

if (ShortCondition == true)
   {
   return(true);
   }
   else
     {
      return(false);
     }
}


//procedo ad aprire la posizione nel caso si verifichi la condizione

  
void DueMedieCheAprono::ApriLong(ENUM_ORDER_TYPE otype,double askprice,double SL,double TP,int dev,string comment="posizione long")
        {
         trequest.action=TRADE_ACTION_DEAL;
         trequest.type=otype;
         trequest.volume=Lotti;
         trequest.price=askprice;
         trequest.sl=SL;
         trequest.tp=TP;
         trequest.magic=MagicNumber;
         trequest.symbol=symbol;
         trequest.type_filling=ORDER_FILLING_AON;
         // send
         OrderSend(trequest,tresult);
         
}

void DueMedieCheAprono::ApriShort(ENUM_ORDER_TYPE otype,double askprice,double SL,double TP,int dev,string comment="posizione short")
        {
         trequest.action=TRADE_ACTION_DEAL;
         trequest.type=otype;
         trequest.volume=Lotti;
         trequest.price=askprice;
         trequest.sl=SL;
         trequest.tp=TP;
         trequest.magic=MagicNumber;
         trequest.symbol=symbol;
         trequest.type_filling=ORDER_FILLING_AON;
         // send
         OrderSend(trequest,tresult);
         
}